<?php

class DatapocketConfigkeyModuleFrontController extends ModuleFrontController
{

    public function postProcess()
    {
        $data = $this->module->frontControllerHeader();

        $wsKey = (isset($data['key'])) ? $data['key'] : false;
        $permissions = (isset($data['permissions'])) ? $data['permissions'] : false;

        $id_webservice_account = $this->module->getWsKeyId($wsKey);

        die(
            $this->updateWebserviceKey($id_webservice_account, $permissions, $wsKey)
        );
    }

    public function updateWebserviceKey($id_webservice_account, $perm, $wsKey)
    {
        if ($perm == 'read') {
            $newPermissions = ['GET' => 1, 'HEAD' => 1];
        } else if ($perm == 'read_write') {
            $newPermissions = ['GET' => 1, 'POST' => 1, 'PUT' => 1, 'DELETE' => 1, 'HEAD' => 1];
        } else {
            return json_encode([
                'status' => 'error',
                'permissions' => $perm,
                'message' => 'unsupported permission'
            ]);
        }

        $WebserviceKey = new WebserviceKey($id_webservice_account);
        $WebserviceKey->deleteAssociations();

        $resources = WebserviceRequest::getResources();

        $permissions = [];

        foreach ($resources as $key => $value) {
            $permissions[$key] = $newPermissions;
        }

        WebserviceKey::setPermissionForAccount($id_webservice_account, $permissions);

        return json_encode([
            'status' => 'success',
            'key' => $wsKey,
            'permissions' => $perm
        ]);
    }

    public function initContent()
    {
        parent::initContent();

        $this->setTemplate('module:datapocket/views/templates/front/configkey.tpl');
    }
}
