<?php

class DatapocketCreatekeyModuleFrontController extends ModuleFrontController
{

    public function postProcess()
    {
        $data = $this->module->frontControllerHeader();

        $name = (isset($data['name'])) ? $data['name'] : false;

        die(
            $this->createWebserviceKey($name)
        );
    }

    public function createWebserviceKey($name)
    {
        $keyValue = Tools::passwdGen(32);

        $wsKey = new WebserviceKey();
        $wsKey->key = $keyValue;
        $wsKey->description = $name;
        $wsKey->active = true;

        try {
            $wsKey->save();
        } catch (Exception $e) {
            return json_encode([
                'status' => 'error',
                'message' => $e->getMessage(),
            ]);
        }

        $resources = [
            'attachments',
            'carriers',
            'cart_rules',
            'carts',
            'categories',
            'combinations',
            'configurations',
            'countries',
            'currencies',
            'customizations',
            'deliveries',
            'image_types',
            'images',
            'languages',
            'manufacturers',
            'order_carriers',
            'order_cart_rules',
            'order_details',
            'order_histories',
            'order_invoices',
            'order_payments',
            'order_slip',
            'order_states',
            'orders',
            'price_ranges',
            'product_customization_fields',
            'product_feature_values',
            'product_features',
            'product_option_values',
            'product_options',
            'product_suppliers',
            'products',
            'search',
            'shop_groups',
            'shop_urls',
            'shops',
            'specific_price_rules',
            'specific_prices',
            'states',
            'stock_availables',
            'stock_movement_reasons',
            'stock_movements',
            'stocks',
            'suppliers',
            'supply_order_details',
            'supply_order_histories',
            'supply_order_receipt_histories',
            'supply_order_states',
            'supply_orders',
            'tags',
            'tax_rule_groups',
            'tax_rules',
            'taxes',
            'translated_configurations',
            'warehouse_product_locations',
            'warehouses',
            'weight_ranges',
            'zones',
        ];

        $permissions = [];

        foreach ($resources as $resource) {
            $permissions[$resource] = ['GET' => 1, 'POST' => 1, 'PUT' => 1, 'DELETE' => 1, 'HEAD' => 1];
        }

        WebserviceKey::setPermissionForAccount($wsKey->id, $permissions);

        return json_encode([
            'status' => 'success',
            'name' => $name,
            'key' => $keyValue,
            'permissions' => 'read_write'
        ]);
    }

    public function initContent()
    {
        parent::initContent();

        $this->setTemplate('module:datapocket/views/templates/front/createkey.tpl');
    }
}
